tscrunch {

    ; ██     ██  █████  ██████  ███    ██ ██ ███    ██  ██████  
    ; ██     ██ ██   ██ ██   ██ ████   ██ ██ ████   ██ ██       
    ; ██  █  ██ ███████ ██████  ██ ██  ██ ██ ██ ██  ██ ██   ███ 
    ; ██ ███ ██ ██   ██ ██   ██ ██  ██ ██ ██ ██  ██ ██ ██    ██ 
    ;  ███ ███  ██   ██ ██   ██ ██   ████ ██ ██   ████  ██████  
    ;         LIMITED VERSION - VRAM $0000 - $FFFF only

asmsub decompress(uword src @R0, uword dst @R1) {
        %asm {{

                tsget 	= $02	;2 bytes
                lzput 	= $06	;2 bytes
                tstemp	= $08

                decrunch:
                        lda #1
                        sta cx16.VERA_CTRL

                        lda #%00010000
                        sta cx16.VERA_ADDR_H

                        stz cx16.VERA_CTRL
                        sta cx16.VERA_ADDR_H

                        lda cx16.r1L
                        sta cx16.VERA_ADDR_L
                        lda cx16.r1H
                        sta cx16.VERA_ADDR_M

                        ldy #0			

                        lda (tsget),y
                        sta optRun + 1

                        inc tsget
                        bne entry2
                        inc tsget + 1

                entry2:	
                        lda (tsget),y
                        tax

                        bmi rleorlz

                        cmp #$20
                        bcs lz2	

                        ;literal
                        phx
                        tax
                        ldy #0

                        ts_delit_loop:
                        iny
                        lda (tsget),y
                        sta cx16.VERA_DATA0                   
                        dex
                        bne ts_delit_loop

                        ldy #0
                        plx
                        txa
                        inx

                updatezp_noclc:
                        clc
                putnoof:
                        txa
                update_getonly:
                        adc tsget
                        sta tsget
                        bcc entry2
                        inc tsget+1
                        bcs entry2
                                
                rleorlz:
                        and #$7f
                        lsr a

                        bcc ts_delz		

                        ;RLE
                        beq optRun

                plain:
                        ldx #2
                        iny
                        sta tstemp		;number of bytes to de-rle		

                        lda (tsget),y	;fetch rle byte
                        ldy tstemp
                runStart:
                        sta cx16.VERA_DATA0
                ts_derle_loop:
                        dey
                        sta cx16.VERA_DATA0
                        bne ts_derle_loop

                        ;update zero page with a = runlen, x = 2 , y = 0 
                        lda tstemp		
                        bcs updatezp_noclc

                done:	
                        rts	
                ;LZ2	
                lz2:
                        beq done

                        ora #$80

                        cmp #$FE ;Vera latchs values...meh
                        beq lz2vera

                        sec
                        adc cx16.VERA_ADDR_L
                        sta lzput

                        lda cx16.VERA_ADDR_M
                        sbc #$00
                        sta lzput + 1 		

                        lda #1
                        sta cx16.VERA_CTRL

                        lda lzput
                        sta cx16.VERA_ADDR_L
                        lda lzput + 1
                        sta cx16.VERA_ADDR_M

                        lda cx16.VERA_DATA1
                        sta cx16.VERA_DATA0

                        iny		
                        lda cx16.VERA_DATA1
                        sta cx16.VERA_DATA0

                        stz cx16.VERA_CTRL

                        tya ;y = a = 1. 
                        tax ;y = a = x = 1. a + carry = 2
                        dey ;ldy #0

                        beq updatezp_noclc

                lz2vera:
                        sec
                        adc cx16.VERA_ADDR_L
                        sta lzput

                        lda cx16.VERA_ADDR_M
                        sbc #$00
                        sta lzput + 1 		

                        lda #1
                        sta cx16.VERA_CTRL

                        lda lzput
                        sta cx16.VERA_ADDR_L
                        lda lzput + 1
                        sta cx16.VERA_ADDR_M

                        lda cx16.VERA_DATA1
                        sta cx16.VERA_DATA0
                        sta cx16.VERA_DATA0

                        iny		

                        stz cx16.VERA_CTRL

                        tya ;y = a = 1. 
                        tax ;y = a = x = 1. a + carry = 2
                        dey ;ldy #0

                        beq updatezp_noclc

                ;LZ
                ts_delz:

                        lsr a
                        sta lzto + 1

                        iny

                        lda #0
                        sta cx16.VERA_CTRL

                        lda cx16.VERA_ADDR_L

                        bcc long


                        sbc (tsget),y
                        sta lzput

                        lda cx16.VERA_ADDR_M

                        sbc #$00

                        ldx #2
                ;lz MUST decrunch forward	
                lz_put:
                        sta lzput+1

                        lda #1
                        sta cx16.VERA_CTRL

                        lda lzput
                        sta cx16.VERA_ADDR_L
                        lda lzput + 1
                        sta cx16.VERA_ADDR_M

                        ldy #0

                        lda cx16.VERA_DATA1
                        sta cx16.VERA_DATA0

                ts_delz_loop:

                        iny

                        lda cx16.VERA_DATA1
                        sta cx16.VERA_DATA0

                lzto:	cpy #0
                        bne ts_delz_loop 

                        tya

                        stz cx16.VERA_CTRL

                        ;update zero page with a = runlen, x = 2, y = 0
                        ldy #0
                        ;clc not needed as we have len - 1 in A (from the encoder) and C = 1			
                        bcs updatezp_noclc


                optRun:	
                        ldy #255
                        sty tstemp

                        ldx #1
                        ;A is zero		
                        bne runStart		

                long:
                        ;carry is clear and compensated for from the encoder
                        adc (tsget),y
                        sta lzput
                        iny
                        lda (tsget),y
                        tax

                        ora #$80
                        adc cx16.VERA_ADDR_M

                        cpx #$80
                        rol lzto + 1
                        ldx #3

                        bne lz_put
                        rts
        }}
}
}   